docusign.template-documents.put-template-documents ​
Adds one or more documents to an existing template document.
Adds documents to a template document.
Overview ​
| Property | Value |
|---|---|
| Workflow type | Atomic |
| Library | App-docusign |
| Version | 1.0 |
Input Schema ​
| Field | Type | Required | Default | Description |
|---|---|---|---|---|
base_url | string | Yes | — | Docusign API root, e.g. https://<host>/api |
api_token | string | No | — | Bearer token; omit to use the workflow's token env var |
accountid | string | Yes | — | The external account number (int) or account ID GUID. |
templateid | string | Yes | — | The ID of the template. |
accesscontrollistbase64 | string | No | — | Reserved for Docusign. |
accessibility | string | No | — | Sets the document reading zones for screen reader applications. This element can only be used if Document Accessibility is enabled for the account. Note: This information is currently generated from the Docusign web console by setting the reading zones when creating a template, exporting the reading zone string information, and adding it here. |
allowcomments | string | No | — | When true, comments are allowed on the envelope. |
allowmarkup | string | No | — | When true, the Document Markup feature is enabled. Note: To use this feature, Document Markup must be enabled at both the account and envelope levels. Only Admin users can change this setting at the account level. |
allowreassign | string | No | — | When true, the recipient can redirect an envelope to a more appropriate recipient. |
allowrecipientrecursion | string | No | — | When true, this enables the Recursive Recipients feature and allows a recipient to appear more than once in the routing order. |
allowviewhistory | string | No | — | When true, users can view the history of the envelope. |
anysigner | string | No | — | Deprecated. This feature has been replaced by signing groups. |
asynchronous | string | No | — | When true, the envelope is queued for processing and the value of the status property is set to Processing. Additionally, GET status calls return Processing until completed. Note: A transactionId is required for this call to work correctly. When the envelope is created, the status is Processing and an envelopeId is not returned in the response. To get the envelopeId, use a GET envelope query by using the transactionId or by checking the Connect notification. |
attachments | list | No | — | An array of attachment objects containing details about any envelope attachments. |
attachmentsuri | string | No | — | The URI for retrieving the envelope attachments. |
authoritativecopy | string | No | — | When true, marks all of the documents in the envelope as authoritative copies. Note: You can override this value for a specific document. For example, you can set the authoritativeCopy property to true at the envelope level, but turn it off for a single document by setting the authoritativeCopy property for the document to false. |
authoritativecopydefault | string | No | — | The default authoritativeCopy setting for documents in this envelope that do not have authoritativeCopy set. If this property is not set, each document defaults to the envelope's authoritativeCopy. |
autonavigation | string | No | — | When true, autonavigation is set for the recipient. |
brandid | string | No | — | The ID of the brand, or text and formatting, to use for the envelope. To use brands, account branding must be enabled for the account. Note: When creating an envelope using a branded template, include this value to ensure that the brand is applied. |
brandlock | string | No | — | When true, the brandId for the envelope is locked and senders cannot change the brand used for the envelope. |
burndefaulttabdata | string | No | — | — |
certificateuri | string | No | — | The URI for retrieving certificate information. |
completeddatetime | string | No | — | The date and time that the envelope was completed. |
compositetemplates | list | No | — | A complex type that can be added to create envelopes from a combination of Docusign templates and PDF forms. The basic envelope remains the same, while the Composite Template adds new document and template overlays into the envelope. There can be any number of Composite Template structures in the envelope. |
copyrecipientdata | string | No | — | This value is only applicable when copying an existing envelope. Provide the ID of the envelope to clone in envelopeId. When true, the recipient field values of the existing envelope are included. Only values from data entry fields, like checkboxes and radio buttons, will be copied. Fields that require an action, like signatures and initials, will not be included. |
createddatetime | string | No | — | The date and time that the envelope was created. |
customfields | json | No | — | An accountCustomField is an envelope custom field that you set at the account level. Applying custom fields enables account administrators to group and manage envelopes. |
customfieldsuri | string | No | — | The URI for retrieving custom fields. |
declineddatetime | string | No | — | The date and time that the recipient declined the envelope. |
deleteddatetime | string | No | — | The date and time that the envelope was deleted. |
delivereddatetime | string | No | — | The date and time that the envelope was delivered to the recipient. This property is read-only. |
disableresponsivedocument | string | No | — | When true, the responsive document feature is turned off for the envelope. |
documentbase64 | string | No | — | The document's bytes. This field can be used to include a base64 version of the document bytes within an envelope definition instead of sending the document using a multi-part HTTP request. The maximum document size is smaller if this field is used due to the overhead of the base64 encoding. |
documents | list | No | — | A complex element that contains details about the documents associated with the envelope. |
documentscombineduri | string | No | — | The URI for retrieving all of the documents associated with the envelope as a single PDF file. |
documentsuri | string | No | — | The URI for retrieving all of the documents associated with the envelope as separate files. |
emailblurb | string | No | — | This optional element holds the body of the email message that is sent to all envelope recipients. Maximum Length: 10000 characters. |
emailsettings | json | No | — | A complex element that allows the sender to override some envelope email setting information. This can be used to override the Reply To email address and name associated with the envelope and to override the BCC email addresses to which an envelope is sent. When the emailSettings information is used for an envelope, it only applies to that envelope. IMPORTANT: The emailSettings information is not returned in the GET for envelope status. Use GET /email_settings to return information about the emailSettings. EmailSettings consists of: * replyEmailAddressOverride - The Reply To email used for the envelope. Docusign will verify that a correct email format is used, but does not verify that the email is active. Maximum Length: 100 characters. * replyEmailNameOverride - The name associated with the Reply To email address. Maximum Length: 100 characters. * bccEmailAddresses - An array of up to five email addresses to which the envelope is sent to as a BCC email. Only users with canManageAccount setting set to true can use this option. Docusign verifies that the email format is correct, but does not verify that the email is active. Using this overrides the BCC for Email Archive information setting for this envelope. Maximum Length: 100 characters. Example: if your account has BCC for Email Archive set up for the email address 'archive@mycompany.com' and you send an envelope using the BCC Email Override to send a BCC email to 'salesarchive@mycompany.com', then a copy of the envelope is only sent to the 'salesarchive@mycompany.com' email address. |
emailsubject | string | No | — | The subject line of the email message that is sent to all recipients. For information about adding merge field information to the email subject, see Template Email Subject Merge Fields. Note: The subject line is limited to 100 characters, including any merged fields.It is not truncated. It is an error if the text is longer than 100 characters. |
enablewetsign | string | No | — | When true, the signer is allowed to print the document and sign it on paper. |
enforcesignervisibility | string | No | — | When true, the option selected in the Document Visibility section in your account [Sending Settings][sendingsettings] will be enforced for the envelope. See [Fields and Properties][fieldsproperties] for details about document visibility options. Setting enforceSignerVisibility to true also enables you to omit documents from the specified recipients' envelopes by using the excludedDocuments array. Recipients that have an administrative role (Agent, Editor, or Intermediaries) or informational role (Certified Deliveries or Carbon Copies) can always see all of the documents in an envelope, unless they are specifically excluded by using the excludedDocuments setting when an envelope is sent. Documents that do not have tabs are always visible to all recipients, unless they are excluded by using the excludedDocuments setting. Note: To use this functionality, [document visibility][docviz] must be enabled for the account. The document visibility feature is available in all developer accounts, but only in certain production account plans. Contact [Docusign Support][support] or your account manager to find out whether document visibility is available for your production account plan. [docviz]: /docs/esign-rest-api/reference/envelopes/envelopedocumentvisibility/ [sendingsettings]: https://admindemo.docusign.com/authenticate?goTo=sending [fieldsproperties]: https://support.docusign.com/s/document-item?rsc_301&bundleId=pik1583277475390&topicId=xgg1583277350154.html [support]: https://support.docusign.com/en/contactSupport# |
envelopeattachments | list | No | — | An array of attachment objects that provide information about the attachments that are associated with the envelope. |
envelopecustommetadata | json | No | — | — |
envelopedocuments | list | No | — | An array containing information about the documents that are included in the envelope. |
envelopeid | string | No | — | The envelope ID. When used as a request body in Envelopes: create, this is the ID of the envelope to clone. |
envelopeidstamping | string | No | — | When true, Envelope ID Stamping is enabled. After a document or attachment is stamped with an Envelope ID, the ID is seen by all recipients and becomes a permanent part of the document and cannot be removed. |
envelopelocation | string | No | — | Reserved for Docusign. |
envelopemetadata | json | No | — | — |
envelopeuri | string | No | — | The URI for retrieving the envelope or envelopes. |
eventnotification | json | No | — | Use this object to configure a Docusign Connect webhook. |
expireafter | string | No | — | Not used. Use the expirations property in the notification object instead. |
expiredatetime | string | No | — | Not used. Use the expirations property in the notification object instead. |
expireenabled | string | No | — | Not used. Use the expirations property in the notification object instead. |
externalenvelopeid | string | No | — | May contain an external identifier for the envelope. |
folders | list | No | — | An array of folders that the envelope belongs to. |
hascomments | string | No | — | When true, indicates that users have added comments to the envelope. |
hasformdatachanged | string | No | — | When true, indicates that the form data associated with the envelope has changed since it was sent. When false, this property does not appear in the response. |
haswavfile | string | No | — | When true, indicates that a wave file (voice recording) is part of the envelope. |
holder | string | No | — | Reserved for Docusign. |
initialsentdatetime | string | No | — | The date and time that the envelope was first sent. |
is21cfrpart11 | string | No | — | When true, indicates compliance with United States Food and Drug Administration (FDA) regulations on electronic records and electronic signatures (ERES). |
isdynamicenvelope | string | No | — | When true, indicates that the envelope is a dynamic envelope. |
issignatureproviderenvelope | string | No | — | When true, indicates that the envelope is a signature-provided envelope. |
isticketrelatedenvelope | string | No | — | — |
lastmodifieddatetime | string | No | — | The date and time that the item was last modified. |
location | string | No | — | Reserved for Docusign. |
lockinformation | json | No | — | Envelope locks let you lock an envelope to prevent any changes while you are updating an envelope. |
messagelock | string | No | — | When true, prevents senders from changing the contents of emailBlurb and emailSubject properties for the envelope. Additionally, this prevents users from making changes to the contents of emailBlurb and emailSubject properties when correcting envelopes. However, if the messageLock node is set to true and the emailSubject property is empty, senders and correctors are able to add a subject to the envelope. |
notification | json | No | — | A complex element that specifies the notification settings for the envelope. |
notificationuri | string | No | — | The URI for retrieving notifications. |
password | string | No | — | The user's password. This property is used only when adding a new user via a Users: create request. The value must conform to the password rules defined in the account Security Settings. This property is not returned by GET requests and cannot be updated via PUT requests. |
powerform | json | No | — | Contains details about a PowerForm. |
purgecompleteddate | string | No | — | The date that a purge was completed. |
purgerequestdate | string | No | — | The date that a purge was requested. |
purgestate | string | No | — | Initiates a purge request. Valid values are: - documents_queued: Places envelope documents in the purge queue. - documents_and_metadata_queued: Places envelope documents and metadata in the purge queue. - documents_and_metadata_and_redact_queued: Places envelope documents and metadata in the purge queue and redacts personal information. Related topics - Purging documents (eSingature Concepts) - Purging documents in an envelope (blog post) |
recipients | json | No | — | Envelope recipients |
recipientslock | string | No | — | When true, prevents senders from changing, correcting, or deleting the recipient information for the envelope. |
recipientsuri | string | No | — | Contains a URI for an endpoint that you can use to retrieve the recipients. |
recipientviewrequest | json | No | — | The request body for the EnvelopeViews: createRecipient and EnvelopeViews: createSharedRecipient methods. |
sender | json | No | — | — |
sentdatetime | string | No | — | The UTC DateTime when the envelope was sent. This property is read-only. |
signercansignonmobile | string | No | — | When true, recipients can sign on a mobile device. Note: Only Admin users can change this setting. |
signinglocation | string | No | — | Specifies the physical location where the signing takes place. It can have two enumeration values; inPerson and online. The default value is online. |
status | string | No | — | Indicates the envelope status. Valid values when creating an envelope are: * created: The envelope is created as a draft. It can be modified and sent later. * sent: The envelope will be sent to the recipients after the envelope is created. You can query these additional statuses once the recipients have interacted with the envelope. * completed: The recipients have finished working with the envelope: the documents are signed and all required tabs are filled in. * declined: The envelope has been declined by the recipients. * delivered: The envelope has been delivered to the recipients. * signed: The envelope has been signed by the recipients. * voided: The envelope is no longer valid and recipients cannot access or sign the envelope. |
statuschangeddatetime | string | No | — | The data and time that the status changed. |
templateid_2 | string | No | — | The ID of the template. If a value is not provided, Docusign generates a value. |
templateroles | list | No | — | This object specifies the template recipients. Each roleName in the template must have a recipient assigned to it. This object is comprised of the following elements: * email: The recipient's email address. * name: The recipient's name. * roleName: The template roleName associated with the recipient. * clientUserId: An optional property that specifies whether the recipient is embedded or remote. If the clientUserId is not null, then the recipient is embedded. Note that if a clientUserId is used and the account settings signerMustHaveAccount or signerMustLoginToSign are true, an error is generated on sending. * defaultRecipient: Optional, When true, this recipient is the default recipient and any tabs generated by the transformPdfFields option are mapped to this recipient. * routingOrder: This specifies the routing order of the recipient in the envelope. * accessCode: This optional element specifies the access code a recipient has to enter to validate the identity. Maximum Length: 50 characters. * inPersonSignerName: Optional. If the template role is an in-person signer, this is the full legal name of the signer. Maximum Length: 100 characters. * emailNotification: This is an optional complex element that has a role-specific emailSubject, emailBody, and language. It follows the same format as the emailNotification property for recipients. * tabs: This property enables the tab values to be specified for matching to tabs in the template. |
templatesuri | string | No | — | The URI for retrieving any templates associated with the envelope. |
transactionid | string | No | — | Used to identify an envelope. The ID is a sender-generated value and is valid in the Docusign system for 7 days. Docusign recommends that you use a transaction ID for offline signing to ensure that an envelope is not sent multiple times. You can use the transactionId property to determine an envelope's status (i.e. was it created or not) in cases where the Internet connection was lost before the envelope status was returned. |
usedisclosure | string | No | — | When true, the disclosure is shown to recipients in accordance with the account's Electronic Record and Signature Disclosure frequency setting. When false, the Electronic Record and Signature Disclosure is not shown to any envelope recipients. If the useDisclosure property is not set, then the account's normal disclosure setting is used and the value of the useDisclosure property is not returned in responses when getting envelope information. |
usigstate | string | No | — | — |
voideddatetime | string | No | — | The date and time the envelope or template was voided. |
voidedreason | string | No | — | The reason the envelope or template was voided. Note: The string is truncated to the first 200 characters. |
workflow | json | No | — | Describes the workflow for an envelope. |
Output Schema ​
| Field | Type | Required | Default | Description |
|---|---|---|---|---|
base_url | string | Yes | — | Docusign API root, e.g. https://<host>/api |
api_token | string | No | — | Bearer token; omit to use the workflow's token env var |
accountid | string | Yes | — | The external account number (int) or account ID GUID. |
templateid | string | Yes | — | The ID of the template. |
accesscontrollistbase64 | string | No | — | Reserved for Docusign. |
accessibility | string | No | — | Sets the document reading zones for screen reader applications. This element can only be used if Document Accessibility is enabled for the account. Note: This information is currently generated from the Docusign web console by setting the reading zones when creating a template, exporting the reading zone string information, and adding it here. |
allowcomments | string | No | — | When true, comments are allowed on the envelope. |
allowmarkup | string | No | — | When true, the Document Markup feature is enabled. Note: To use this feature, Document Markup must be enabled at both the account and envelope levels. Only Admin users can change this setting at the account level. |
allowreassign | string | No | — | When true, the recipient can redirect an envelope to a more appropriate recipient. |
allowrecipientrecursion | string | No | — | When true, this enables the Recursive Recipients feature and allows a recipient to appear more than once in the routing order. |
allowviewhistory | string | No | — | When true, users can view the history of the envelope. |
anysigner | string | No | — | Deprecated. This feature has been replaced by signing groups. |
asynchronous | string | No | — | When true, the envelope is queued for processing and the value of the status property is set to Processing. Additionally, GET status calls return Processing until completed. Note: A transactionId is required for this call to work correctly. When the envelope is created, the status is Processing and an envelopeId is not returned in the response. To get the envelopeId, use a GET envelope query by using the transactionId or by checking the Connect notification. |
attachments | list | No | — | An array of attachment objects containing details about any envelope attachments. |
attachmentsuri | string | No | — | The URI for retrieving the envelope attachments. |
authoritativecopy | string | No | — | When true, marks all of the documents in the envelope as authoritative copies. Note: You can override this value for a specific document. For example, you can set the authoritativeCopy property to true at the envelope level, but turn it off for a single document by setting the authoritativeCopy property for the document to false. |
authoritativecopydefault | string | No | — | The default authoritativeCopy setting for documents in this envelope that do not have authoritativeCopy set. If this property is not set, each document defaults to the envelope's authoritativeCopy. |
autonavigation | string | No | — | When true, autonavigation is set for the recipient. |
brandid | string | No | — | The ID of the brand, or text and formatting, to use for the envelope. To use brands, account branding must be enabled for the account. Note: When creating an envelope using a branded template, include this value to ensure that the brand is applied. |
brandlock | string | No | — | When true, the brandId for the envelope is locked and senders cannot change the brand used for the envelope. |
burndefaulttabdata | string | No | — | — |
certificateuri | string | No | — | The URI for retrieving certificate information. |
completeddatetime | string | No | — | The date and time that the envelope was completed. |
compositetemplates | list | No | — | A complex type that can be added to create envelopes from a combination of Docusign templates and PDF forms. The basic envelope remains the same, while the Composite Template adds new document and template overlays into the envelope. There can be any number of Composite Template structures in the envelope. |
copyrecipientdata | string | No | — | This value is only applicable when copying an existing envelope. Provide the ID of the envelope to clone in envelopeId. When true, the recipient field values of the existing envelope are included. Only values from data entry fields, like checkboxes and radio buttons, will be copied. Fields that require an action, like signatures and initials, will not be included. |
createddatetime | string | No | — | The date and time that the envelope was created. |
customfields | json | No | — | An accountCustomField is an envelope custom field that you set at the account level. Applying custom fields enables account administrators to group and manage envelopes. |
customfieldsuri | string | No | — | The URI for retrieving custom fields. |
declineddatetime | string | No | — | The date and time that the recipient declined the envelope. |
deleteddatetime | string | No | — | The date and time that the envelope was deleted. |
delivereddatetime | string | No | — | The date and time that the envelope was delivered to the recipient. This property is read-only. |
disableresponsivedocument | string | No | — | When true, the responsive document feature is turned off for the envelope. |
documentbase64 | string | No | — | The document's bytes. This field can be used to include a base64 version of the document bytes within an envelope definition instead of sending the document using a multi-part HTTP request. The maximum document size is smaller if this field is used due to the overhead of the base64 encoding. |
documents | list | No | — | A complex element that contains details about the documents associated with the envelope. |
documentscombineduri | string | No | — | The URI for retrieving all of the documents associated with the envelope as a single PDF file. |
documentsuri | string | No | — | The URI for retrieving all of the documents associated with the envelope as separate files. |
emailblurb | string | No | — | This optional element holds the body of the email message that is sent to all envelope recipients. Maximum Length: 10000 characters. |
emailsettings | json | No | — | A complex element that allows the sender to override some envelope email setting information. This can be used to override the Reply To email address and name associated with the envelope and to override the BCC email addresses to which an envelope is sent. When the emailSettings information is used for an envelope, it only applies to that envelope. IMPORTANT: The emailSettings information is not returned in the GET for envelope status. Use GET /email_settings to return information about the emailSettings. EmailSettings consists of: * replyEmailAddressOverride - The Reply To email used for the envelope. Docusign will verify that a correct email format is used, but does not verify that the email is active. Maximum Length: 100 characters. * replyEmailNameOverride - The name associated with the Reply To email address. Maximum Length: 100 characters. * bccEmailAddresses - An array of up to five email addresses to which the envelope is sent to as a BCC email. Only users with canManageAccount setting set to true can use this option. Docusign verifies that the email format is correct, but does not verify that the email is active. Using this overrides the BCC for Email Archive information setting for this envelope. Maximum Length: 100 characters. Example: if your account has BCC for Email Archive set up for the email address 'archive@mycompany.com' and you send an envelope using the BCC Email Override to send a BCC email to 'salesarchive@mycompany.com', then a copy of the envelope is only sent to the 'salesarchive@mycompany.com' email address. |
emailsubject | string | No | — | The subject line of the email message that is sent to all recipients. For information about adding merge field information to the email subject, see Template Email Subject Merge Fields. Note: The subject line is limited to 100 characters, including any merged fields.It is not truncated. It is an error if the text is longer than 100 characters. |
enablewetsign | string | No | — | When true, the signer is allowed to print the document and sign it on paper. |
enforcesignervisibility | string | No | — | When true, the option selected in the Document Visibility section in your account [Sending Settings][sendingsettings] will be enforced for the envelope. See [Fields and Properties][fieldsproperties] for details about document visibility options. Setting enforceSignerVisibility to true also enables you to omit documents from the specified recipients' envelopes by using the excludedDocuments array. Recipients that have an administrative role (Agent, Editor, or Intermediaries) or informational role (Certified Deliveries or Carbon Copies) can always see all of the documents in an envelope, unless they are specifically excluded by using the excludedDocuments setting when an envelope is sent. Documents that do not have tabs are always visible to all recipients, unless they are excluded by using the excludedDocuments setting. Note: To use this functionality, [document visibility][docviz] must be enabled for the account. The document visibility feature is available in all developer accounts, but only in certain production account plans. Contact [Docusign Support][support] or your account manager to find out whether document visibility is available for your production account plan. [docviz]: /docs/esign-rest-api/reference/envelopes/envelopedocumentvisibility/ [sendingsettings]: https://admindemo.docusign.com/authenticate?goTo=sending [fieldsproperties]: https://support.docusign.com/s/document-item?rsc_301&bundleId=pik1583277475390&topicId=xgg1583277350154.html [support]: https://support.docusign.com/en/contactSupport# |
envelopeattachments | list | No | — | An array of attachment objects that provide information about the attachments that are associated with the envelope. |
envelopecustommetadata | json | No | — | — |
envelopedocuments | list | No | — | An array containing information about the documents that are included in the envelope. |
envelopeid | string | No | — | The envelope ID. When used as a request body in Envelopes: create, this is the ID of the envelope to clone. |
envelopeidstamping | string | No | — | When true, Envelope ID Stamping is enabled. After a document or attachment is stamped with an Envelope ID, the ID is seen by all recipients and becomes a permanent part of the document and cannot be removed. |
envelopelocation | string | No | — | Reserved for Docusign. |
envelopemetadata | json | No | — | — |
envelopeuri | string | No | — | The URI for retrieving the envelope or envelopes. |
eventnotification | json | No | — | Use this object to configure a Docusign Connect webhook. |
expireafter | string | No | — | Not used. Use the expirations property in the notification object instead. |
expiredatetime | string | No | — | Not used. Use the expirations property in the notification object instead. |
expireenabled | string | No | — | Not used. Use the expirations property in the notification object instead. |
externalenvelopeid | string | No | — | May contain an external identifier for the envelope. |
folders | list | No | — | An array of folders that the envelope belongs to. |
hascomments | string | No | — | When true, indicates that users have added comments to the envelope. |
hasformdatachanged | string | No | — | When true, indicates that the form data associated with the envelope has changed since it was sent. When false, this property does not appear in the response. |
haswavfile | string | No | — | When true, indicates that a wave file (voice recording) is part of the envelope. |
holder | string | No | — | Reserved for Docusign. |
initialsentdatetime | string | No | — | The date and time that the envelope was first sent. |
is21cfrpart11 | string | No | — | When true, indicates compliance with United States Food and Drug Administration (FDA) regulations on electronic records and electronic signatures (ERES). |
isdynamicenvelope | string | No | — | When true, indicates that the envelope is a dynamic envelope. |
issignatureproviderenvelope | string | No | — | When true, indicates that the envelope is a signature-provided envelope. |
isticketrelatedenvelope | string | No | — | — |
lastmodifieddatetime | string | No | — | The date and time that the item was last modified. |
location | string | No | — | Reserved for Docusign. |
lockinformation | json | No | — | Envelope locks let you lock an envelope to prevent any changes while you are updating an envelope. |
messagelock | string | No | — | When true, prevents senders from changing the contents of emailBlurb and emailSubject properties for the envelope. Additionally, this prevents users from making changes to the contents of emailBlurb and emailSubject properties when correcting envelopes. However, if the messageLock node is set to true and the emailSubject property is empty, senders and correctors are able to add a subject to the envelope. |
notification | json | No | — | A complex element that specifies the notification settings for the envelope. |
notificationuri | string | No | — | The URI for retrieving notifications. |
password | string | No | — | The user's password. This property is used only when adding a new user via a Users: create request. The value must conform to the password rules defined in the account Security Settings. This property is not returned by GET requests and cannot be updated via PUT requests. |
powerform | json | No | — | Contains details about a PowerForm. |
purgecompleteddate | string | No | — | The date that a purge was completed. |
purgerequestdate | string | No | — | The date that a purge was requested. |
purgestate | string | No | — | Initiates a purge request. Valid values are: - documents_queued: Places envelope documents in the purge queue. - documents_and_metadata_queued: Places envelope documents and metadata in the purge queue. - documents_and_metadata_and_redact_queued: Places envelope documents and metadata in the purge queue and redacts personal information. Related topics - Purging documents (eSingature Concepts) - Purging documents in an envelope (blog post) |
recipients | json | No | — | Envelope recipients |
recipientslock | string | No | — | When true, prevents senders from changing, correcting, or deleting the recipient information for the envelope. |
recipientsuri | string | No | — | Contains a URI for an endpoint that you can use to retrieve the recipients. |
recipientviewrequest | json | No | — | The request body for the EnvelopeViews: createRecipient and EnvelopeViews: createSharedRecipient methods. |
sender | json | No | — | — |
sentdatetime | string | No | — | The UTC DateTime when the envelope was sent. This property is read-only. |
signercansignonmobile | string | No | — | When true, recipients can sign on a mobile device. Note: Only Admin users can change this setting. |
signinglocation | string | No | — | Specifies the physical location where the signing takes place. It can have two enumeration values; inPerson and online. The default value is online. |
status | string | No | — | Indicates the envelope status. Valid values when creating an envelope are: * created: The envelope is created as a draft. It can be modified and sent later. * sent: The envelope will be sent to the recipients after the envelope is created. You can query these additional statuses once the recipients have interacted with the envelope. * completed: The recipients have finished working with the envelope: the documents are signed and all required tabs are filled in. * declined: The envelope has been declined by the recipients. * delivered: The envelope has been delivered to the recipients. * signed: The envelope has been signed by the recipients. * voided: The envelope is no longer valid and recipients cannot access or sign the envelope. |
statuschangeddatetime | string | No | — | The data and time that the status changed. |
templateid_2 | string | No | — | The ID of the template. If a value is not provided, Docusign generates a value. |
templateroles | list | No | — | This object specifies the template recipients. Each roleName in the template must have a recipient assigned to it. This object is comprised of the following elements: * email: The recipient's email address. * name: The recipient's name. * roleName: The template roleName associated with the recipient. * clientUserId: An optional property that specifies whether the recipient is embedded or remote. If the clientUserId is not null, then the recipient is embedded. Note that if a clientUserId is used and the account settings signerMustHaveAccount or signerMustLoginToSign are true, an error is generated on sending. * defaultRecipient: Optional, When true, this recipient is the default recipient and any tabs generated by the transformPdfFields option are mapped to this recipient. * routingOrder: This specifies the routing order of the recipient in the envelope. * accessCode: This optional element specifies the access code a recipient has to enter to validate the identity. Maximum Length: 50 characters. * inPersonSignerName: Optional. If the template role is an in-person signer, this is the full legal name of the signer. Maximum Length: 100 characters. * emailNotification: This is an optional complex element that has a role-specific emailSubject, emailBody, and language. It follows the same format as the emailNotification property for recipients. * tabs: This property enables the tab values to be specified for matching to tabs in the template. |
templatesuri | string | No | — | The URI for retrieving any templates associated with the envelope. |
transactionid | string | No | — | Used to identify an envelope. The ID is a sender-generated value and is valid in the Docusign system for 7 days. Docusign recommends that you use a transaction ID for offline signing to ensure that an envelope is not sent multiple times. You can use the transactionId property to determine an envelope's status (i.e. was it created or not) in cases where the Internet connection was lost before the envelope status was returned. |
usedisclosure | string | No | — | When true, the disclosure is shown to recipients in accordance with the account's Electronic Record and Signature Disclosure frequency setting. When false, the Electronic Record and Signature Disclosure is not shown to any envelope recipients. If the useDisclosure property is not set, then the account's normal disclosure setting is used and the value of the useDisclosure property is not returned in responses when getting envelope information. |
usigstate | string | No | — | — |
voideddatetime | string | No | — | The date and time the envelope or template was voided. |
voidedreason | string | No | — | The reason the envelope or template was voided. Note: The string is truncated to the first 200 characters. |
workflow | json | No | — | Describes the workflow for an envelope. |
status_code | integer | No | — | HTTP status code of the completed call |
response | json | No | — | Parsed JSON response body |
failure_reason | string | No | — | — |
failure_type | string | No | — | — |
failed_at | string | No | — | — |
failed_step | string | No | — | — |
failed_layer | string | No | — | — |
failed_at_state | string | No | — | — |
error | string | No | — | — |
error_type | string | No | — | — |
States ​
| State | Initial | Terminal | Success | Auto-advance | Description |
|---|---|---|---|---|---|
pending | Yes | No | — | execute | Waiting to call PUT /v2.1/accounts/{accountId}/templates/{templateId}/documents |
completed | No | Yes | Yes | — | HTTP call succeeded |
failed | No | Yes | No | — | HTTP call failed |
State Diagram ​
Transitions ​
| From | Action | To | Description |
|---|---|---|---|
pending | execute | completed | Perform PUT /v2.1/accounts/{accountId}/templates/{templateId}/documents |
* (any state) | fail | failed | Record the failure reason |
API Usage ​
bash
POST /api/workflows/start
Content-Type: application/json
{
"workflow_type": "docusign.template-documents.put-template-documents",
"initial_data": {
"base_url": "value",
"accountid": "value",
"templateid": "value"
}
}